#include <stdio.h>
#include <stdlib.h>

#include "pico/stdlib.h"
#include "hardware/clocks.h"
#include "hardware/irq.h"
#include "hardware/pwm.h"
#include "ws2812.pio.h"

const int PIN_TX = 6;

int RGB_LED_Test() {
    stdio_init_all();
    sleep_ms(200);
    PIO pio = pio0;
    int sm = 0;
    uint offset = pio_add_program(pio, &ws2812_program);
    ws2812_program_init(pio, sm, offset, PIN_TX, 800000, false); //rgb
    UDOUBLE Imagesize = RGB_16x10_HEIGHT*RGB_16x10_WIDTH*2;
    UWORD *BlackImage;
    if((BlackImage = (UWORD *)malloc(Imagesize)) == NULL) {
        printf("Failed to apply for black memory...\r\n");
        exit(0);
    }
    Paint_NewImage((UBYTE *)BlackImage,RGB_16x10_WIDTH,RGB_16x10_HEIGHT, 0, WHITE);
    Paint_SetScale(65);
    Paint_SetRotate(ROTATE_0);
    Paint_Clear(BLACK); 
    //char a[] = "0";
   //WHITE BLACK BLUE RED GREEN CYAN YELLOW PURPLE


#if 1 
    Paint_DrawLine( 1,  1, 16, 1, CYAN, DOT_PIXEL_1X1, LINE_STYLE_SOLID);
    Paint_DrawLine( 1,  2, 16, 2, YELLOW, DOT_PIXEL_1X1, LINE_STYLE_SOLID);
    Paint_DrawLine( 1,  9, 16, 9, PURPLE, DOT_PIXEL_1X1, LINE_STYLE_SOLID);
    Paint_DrawLine( 1,  10, 16, 10, WHITE, DOT_PIXEL_1X1, LINE_STYLE_SOLID);
    show(BlackImage,RGB_1F);
    sleep_ms(500);
    Paint_DrawRectangle(2, 4, 5, 7, RED, DOT_PIXEL_1X1,DRAW_FILL_EMPTY);
    show(BlackImage,RGB_1F);
    sleep_ms(500);
    Paint_DrawRectangle(7, 4, 10, 8, GREEN, DOT_PIXEL_1X1,DRAW_FILL_FULL); 
    show(BlackImage,RGB_1F);
    sleep_ms(500);
    Paint_DrawRectangle(12, 4, 15, 7, BLUE, DOT_PIXEL_1X1,DRAW_FILL_EMPTY);   
    show(BlackImage,RGB_1F);
    sleep_ms(500);

#endif
 

#if 1
    for(int i =0;i<3;i++)
        RGB_Breathing(); 
        while(1)
        Rainbow();  
       
#endif       
                   
    
    free(BlackImage);
    BlackImage = NULL; 
    return 0;
}
